#include <stdio.h>
#include <gtk/gtk.h>
#include <pthread.h>
enum {
	LICENSE=1,
	CHOICE,
	SETUP,
	PROGRESS,
	FINAL,
	INSTALL,
	UNINSTALL,
	UPDATE
};

enum {
	PRECOMPILED=0,
	BUILD
};

void show_license_screen();
void show_setup_screen();
void show_progress_screen();
void show_final_screen(); 
void show_uninstall_screen();
void show_update_screen();
void show_choice_screen();

/* VERSION OF GTK: 1.2 */
GtkWidget *window,*pathtext=NULL;
int current_screen,choice,build_choice=PRECOMPILED;
GtkWidget *choice1,*choice2,*choice3;

gint delete_event( GtkWidget *widget,GdkEvent *event,gpointer data )
{
	return TRUE;
}

void destroy( GtkWidget *widget,gpointer data )
{
	gtk_widget_destroy(window);
	gtk_main_quit ();
	exit(0);
}

GtkWidget *filew;

void file_ok_sel (GtkWidget *w, GtkFileSelection *fs)
{
	g_print ("%s\n", gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
	gtk_widget_destroy(filew);
}

void show_filebrowser( GtkWidget *widget,gpointer data ) {
	filew = gtk_file_selection_new ("File selection");
	
	gtk_signal_connect (GTK_OBJECT (filew), "destroy",(GtkSignalFunc) gtk_widget_destroy,GTK_OBJECT(filew));
	gtk_signal_connect (GTK_OBJECT (filew), "delete_event",(GtkSignalFunc) gtk_widget_destroy,GTK_OBJECT(filew));
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),"clicked", (GtkSignalFunc)file_ok_sel,filew );
	gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(filew)->cancel_button),"clicked", (GtkSignalFunc) gtk_widget_destroy,GTK_OBJECT (filew));
	gtk_widget_show(filew);	
}

gchar *path;
char *install_path;
GtkWidget *popup;

void close_popup( GtkWidget *widget,gpointer data )
{
	gtk_widget_destroy(popup);
	gtk_main_quit ();
	if(current_screen==SETUP)
		show_setup_screen();
}


void createPopup(char *msg) {
	GtkWidget *label,*vbox,*hbox,*button;
	
	popup = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_position(GTK_WINDOW(popup),GTK_WIN_POS_CENTER);
	gtk_container_set_border_width (GTK_CONTAINER (popup), 10);
	gtk_signal_connect (GTK_OBJECT (popup), "delete_event",GTK_SIGNAL_FUNC(close_popup), NULL);

	vbox=gtk_vbox_new(FALSE,0);
	hbox=gtk_hbox_new(FALSE,0);

	label=gtk_label_new(msg);
	gtk_box_pack_start(GTK_BOX(vbox),label,FALSE,FALSE,0);
	gtk_widget_show (label);

	button = gtk_button_new_with_label ("Close");
	gtk_signal_connect(GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC(close_popup),NULL);
	gtk_widget_show(button);

	gtk_box_pack_end(GTK_BOX(hbox),button,FALSE,FALSE,0);
	gtk_widget_show(hbox);

	gtk_box_pack_start(GTK_BOX(vbox),label,TRUE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	
	gtk_container_add (GTK_CONTAINER (popup), vbox);
	gtk_widget_show (vbox);
	gtk_widget_show (popup);
	gtk_main();
}

void next_screen( GtkWidget *widget,gpointer data ) {

	if(pathtext) {
		path=gtk_entry_get_text(GTK_ENTRY(pathtext));
		pathtext=NULL;
		install_path=(char *)strdup(path);
	}
	
	if(window) { 
		gtk_widget_destroy(window);
		gtk_main_quit();
	}

	switch(current_screen) {
		case LICENSE:
			show_choice_screen();
			break;
		case CHOICE:
			if(choice==INSTALL)
				show_setup_screen();
			else if(choice==UNINSTALL || choice==UPDATE) {
				show_progress_screen();
			}
			break;
		case SETUP:
			if(!install_path || strlen(install_path)==0) {
				createPopup("You should provide an installation path");
				break;
			}
		case UNINSTALL:
		case UPDATE:
			show_progress_screen();
			break;
		case PROGRESS:
			show_final_screen();
			break;
		default:
			printf("Unreachable\n");
			exit(-1);
	}
}

void previous_screen(GtkWidget *widget, gpointer data) {
	
	if(window) { 
		gtk_widget_destroy(window);
		gtk_main_quit();
	}

	switch(current_screen) {
		case LICENSE:
			show_license_screen();
			break;
		case CHOICE:
			show_license_screen();
			break;
		case SETUP:
			show_choice_screen();
			break;
		case PROGRESS:
			show_setup_screen();
			break;
		default:
			printf("Unreachable\n");
			exit(-1);
	}
}

GtkWidget *createButtonBox() {
	GtkWidget *button,*hbox,*vbox,*separator;
	
	hbox=gtk_hbox_new(FALSE,8);
	vbox=gtk_vbox_new(FALSE,0);
	
	button = gtk_button_new_with_label ("   Next >   ");
	gtk_signal_connect(GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC(next_screen),NULL);
	gtk_box_pack_end(GTK_BOX(hbox),button,FALSE,FALSE,0);
	gtk_widget_show (button);
	if(current_screen==PROGRESS)
		gtk_widget_set_sensitive(button,FALSE);
	
	button = gtk_button_new_with_label ("   Cancel   ");
	gtk_signal_connect(GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC(destroy),NULL);
	gtk_box_pack_end(GTK_BOX(hbox),button,FALSE,FALSE,0);
	gtk_widget_show (button);
	if(current_screen==PROGRESS)
		gtk_widget_set_sensitive(button,FALSE);
	
	button = gtk_button_new_with_label ("   < Back   ");
	gtk_signal_connect(GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC(previous_screen),GTK_OBJECT (window));
	gtk_box_pack_end(GTK_BOX(hbox),button,FALSE,FALSE,0);
	gtk_widget_show (button);
	if(current_screen==LICENSE || current_screen==PROGRESS)
		gtk_widget_set_sensitive(button,FALSE);
	
	separator = gtk_hseparator_new ();
	
	gtk_box_pack_start(GTK_BOX(vbox),separator,FALSE,FALSE,0);
	gtk_widget_show (separator);
	gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_widget_show (hbox);
	
	return vbox;	
}

void show_license_screen() {
	GtkWidget *button;
	GtkWidget *vscrollbar;
	GtkWidget *text,*vbox,*hbox;
	FILE *fp;
	char buffer[1024];
	
	current_screen=LICENSE;	
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",GTK_SIGNAL_FUNC(destroy), NULL);
	
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);
	gtk_widget_set_usize(window,600,400);
	gtk_window_set_title(GTK_WINDOW(window),"License");
	gtk_window_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
	
	vbox=gtk_vbox_new(FALSE,0);
	
	text = gtk_text_new (NULL, NULL);                        //create a text box
	gtk_text_set_editable (GTK_TEXT (text), FALSE);          //not editable text
	
	gtk_text_freeze (GTK_TEXT (text));

	//gtk_text_insert (GTK_TEXT (text),NULL, &text->style->black, NULL,"LICENSE AGREEMENT\n\n", -1);
	
	fp=fopen("license.txt","r");
	if(fp) {
	   while(fgets(buffer,1024,fp)!=NULL) {
		gtk_text_insert (GTK_TEXT (text),NULL, &text->style->black, NULL,buffer, -1);
	   }
		fclose(fp);
	}
	else {
		printf("LIcense file missing\n");
		exit(0);
	}
	
	gtk_box_pack_start(GTK_BOX(vbox),text,TRUE,TRUE,0);
	gtk_widget_show (text);
	
	hbox=createButtonBox();	
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_widget_show (vbox);
	gtk_widget_show (hbox);
	gtk_widget_show (window);
	gtk_main ();
}

void show_setup_screen() {
	GtkWidget *button;
	GtkWidget *vbox,*hbox,*hbox2,*label,*filew;

	current_screen=SETUP;

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",GTK_SIGNAL_FUNC(destroy), NULL);
	
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);
	gtk_widget_set_usize(window,300,100);
	gtk_window_set_title(GTK_WINDOW(window),"Setup");
	gtk_window_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
	
	vbox=gtk_vbox_new(FALSE,0);
	hbox=gtk_hbox_new(FALSE,0);
	hbox2=gtk_hbox_new(FALSE,0);
	
	hbox=createButtonBox();

	label=gtk_label_new("Installation path");
	gtk_box_pack_start(GTK_BOX(vbox),label,FALSE,FALSE,0);
	gtk_widget_show (label);
	
	pathtext = gtk_entry_new ();                        //create a text box
	gtk_entry_set_text(GTK_ENTRY(pathtext),"/usr/local/");
	gtk_box_pack_start(GTK_BOX(hbox2),pathtext,TRUE,FALSE,0);
	gtk_widget_show (pathtext);
	
	button = gtk_button_new_with_label ("Browse");
	gtk_signal_connect(GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC(show_filebrowser),GTK_OBJECT (window));
	gtk_box_pack_start(GTK_BOX(hbox2),button,TRUE,FALSE,0);
	gtk_widget_show(button);

	gtk_container_set_border_width (GTK_CONTAINER (hbox2),5);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);

	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_widget_show (vbox);
	gtk_widget_show (hbox);
	gtk_widget_show (hbox2);
	gtk_widget_show (window);
	gtk_main ();
}

GtkWidget *progresslabel;
GtkWidget *progressbar;

enum {
	ERROR_MISSING=1,
	ERROR_EMPTY,
	ERROR_UNINSTALL,
	ERROR_CREATEDIR,
	ERROR_BUILD,
	ERROR_CONFIG
};
int error;

void *do_work(void *ptr) {
	FILE *fp;
	char buffer[100],command[200];

	if(choice==UNINSTALL) {
		usleep(500000);
		gtk_label_set(GTK_LABEL(progresslabel),"Uninstalling iGuard");
		usleep(500000);
		fp=fopen("/etc/iguard.conf","r");
		if(fp==NULL) {
			error=ERROR_MISSING;
			show_final_screen();
			pthread_exit(NULL);
		}
		else {
			if(fgets(buffer,1000,fp)==NULL) {
				error=ERROR_EMPTY;
				show_final_screen();
				pthread_exit(NULL);
			}
			else {
				buffer[strlen(buffer)-1]='\0';
				
				gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbar),0.5);
				usleep(300000);
				sprintf(command,"./scripts/uninstall %s",buffer);
				gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbar),1.0);
				usleep(200000);
				
				if(system(command)==-1) 
					error=ERROR_UNINSTALL;
				show_final_screen();
				pthread_exit(NULL);
			}	
		}
		
	}
	else if(choice==INSTALL) {
		printf(" ))))))))\n");
		usleep(500000);
		gtk_label_set(GTK_LABEL(progresslabel),"Creating directories");
		sprintf(command,"./scripts/createdirs %s/iguard",install_path);
		if(system(command)==-1) {
					error=ERROR_CREATEDIR;
					show_final_screen();
					pthread_exit(NULL);
		}
		gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbar),0.2);
		usleep(300000);
		if(build_choice==BUILD) {
			gtk_label_set(GTK_LABEL(progresslabel),"Configuring...");
			sprintf(command,"./scripts/config %s/iguard",install_path);
			if(system(command)==-1) {
					error=ERROR_CONFIG;
					show_final_screen();
					pthread_exit(NULL);
			}
			gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbar),0.5);
		
			usleep(300000);
			gtk_label_set(GTK_LABEL(progresslabel),"Building...");
			sprintf(command,"./scripts/build %s/iguard",install_path);
			if(system(command)==-1) {
					error=ERROR_BUILD;
					show_final_screen();
					pthread_exit(NULL);
			}
			gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbar),1.0);
			usleep(100000);
		}
		else {
			gtk_label_set(GTK_LABEL(progresslabel),"Installing precompiled version...");
			sprintf(command,"./scripts/precompiled %s/iguard",install_path);
			if(system(command)==-1) {
					error=ERROR_CREATEDIR;
					show_final_screen();
					pthread_exit(NULL);
			}
			gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbar),1.0);
			usleep(1000000);
		}

		show_final_screen();
		pthread_exit(NULL);
	
	}
	
}

void show_progress_screen() {
	GtkWidget *button;
	GtkWidget *text,*vbox,*hbox,*hbox2;
	pthread_t thread;
	int rc;
	
	current_screen=PROGRESS;
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize(window,300,100);
	gtk_window_set_title(GTK_WINDOW(window),"Installing iGuard..");
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",GTK_SIGNAL_FUNC(delete_event), NULL);
	gtk_signal_connect (GTK_OBJECT (window), "destroy",GTK_SIGNAL_FUNC(delete_event), NULL);
	gtk_window_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);
	
	vbox=gtk_vbox_new(FALSE,0);
	hbox=gtk_hbox_new(FALSE,0);
	
	hbox=createButtonBox();

	progresslabel=gtk_label_new("Preparing..");
	gtk_box_pack_start(GTK_BOX(vbox),progresslabel,FALSE,FALSE,0);
	gtk_widget_show (progresslabel);
	
	progressbar=gtk_progress_bar_new();
	gtk_box_pack_start(GTK_BOX(vbox),progressbar,FALSE,FALSE,0);
	gtk_widget_show (progressbar);
	
	gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,FALSE,0);
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_widget_show (vbox);
	gtk_widget_show (hbox);
	gtk_widget_show (window);
	if((rc=pthread_create(&thread,NULL,do_work,NULL))!=0) {
		printf("Error creating threads\n");
		exit(0);
	}
	gtk_main ();
	
	//gtk_progress_bar_set_bar_style(bar,GTK_PROGRESS_CONTINUOUS);
}


void show_final_screen() {
	GtkWidget *label,*button,*vbox,*hbox;
	
	current_screen=FINAL;

	gtk_widget_destroy(window);
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize(window,400,200);
	gtk_window_set_title(GTK_WINDOW(window),"Setup finished");
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",GTK_SIGNAL_FUNC(destroy), NULL);
	gtk_window_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);
	
	vbox=gtk_vbox_new(FALSE,0);
	hbox=gtk_hbox_new(FALSE,0);
	
	button = gtk_button_new_with_label ("Finish");
	gtk_signal_connect(GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC(destroy),NULL);
	gtk_widget_show(button);
	gtk_box_pack_end(GTK_BOX(hbox),button,FALSE,FALSE,0);
	gtk_widget_show(hbox);
	

	if(error!=0) {
		switch(error) {
			case ERROR_MISSING: 
				label=gtk_label_new("~/.iguardrc is missing. \n Check your installation and \nperform uninstall again");
				break;
			case ERROR_EMPTY:
				label=gtk_label_new("~/.iguardrc is empty.\n Check your installation and \nperform uninstall again");
				break;
			case ERROR_BUILD:
				label=gtk_label_new("Error while building iGuard.\n Check ./snort/src/tmp.log for details");
				break;
			case ERROR_CREATEDIR:
				label=gtk_label_new("Error creating directories and iGuard configuration file.\n Please check that you have permissions\n");
				break;
			case ERROR_CONFIG:
				label=gtk_label_new("Error while configuring iGuard.\n Check ./snort/tmp.log for details");
				break;
		}
	}
	else {
		if(choice==UNINSTALL) 
			label=gtk_label_new("Uninstall succesful");
		else if(choice==INSTALL)  {
			char msg[200];
			sprintf(msg,"Installation succesful\n iGuard is under %s/iguard",install_path);
			label=gtk_label_new(msg);
		}
	}
		
	gtk_widget_show (label);
	
	gtk_box_pack_start(GTK_BOX(vbox),label,TRUE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_widget_show (vbox);
	gtk_widget_show (window);
}
void choice_install( GtkWidget *widget,gpointer data )
{
	choice=INSTALL;
}

void choice_uninstall(GtkWidget *widget,gpointer data) {
	choice=UNINSTALL;
}
void choice_update(GtkWidget *widget,gpointer data) {
	choice=UPDATE;
}

void precompile_choice( GtkWidget *widget,gpointer data ) {
	if (GTK_TOGGLE_BUTTON (widget)->active) 
    {
		build_choice=PRECOMPILED;
    } else {
		build_choice=BUILD;
    }
}

void show_choice_screen() {
	GtkWidget *button;
	GtkWidget *text,*vbox,*hbox,*vbox2,*label;
	GtkWidget *progressbar;
	GtkWidget *precompiled;
	

	current_screen=CHOICE;
	choice=INSTALL;
	
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",GTK_SIGNAL_FUNC(destroy), NULL);
	gtk_widget_set_usize(window,300,200);
	gtk_window_set_title(GTK_WINDOW(window),"Choose your option..");
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);
	gtk_window_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);

	vbox=gtk_vbox_new(FALSE,0);
	vbox2=gtk_vbox_new(FALSE,0);
	hbox=gtk_hbox_new(FALSE,0);
	
	choice1=gtk_radio_button_new_with_label(NULL,"Install iGuard");
	gtk_widget_show (choice1);
	gtk_signal_connect(GTK_OBJECT (choice1),"clicked",GTK_SIGNAL_FUNC(choice_install),GTK_OBJECT (window));
	
	precompiled=gtk_check_button_new_with_label ("Install precompiled executable");
	GTK_TOGGLE_BUTTON(precompiled)->active=1;
	gtk_widget_show(precompiled);
	gtk_signal_connect(GTK_OBJECT (precompiled),"clicked",GTK_SIGNAL_FUNC(precompile_choice),GTK_OBJECT (window));
	
	choice2 = gtk_radio_button_new_with_label( gtk_radio_button_group (GTK_RADIO_BUTTON (choice1)), "Uninstall iGuard");
	gtk_signal_connect(GTK_OBJECT (choice2),"clicked",GTK_SIGNAL_FUNC(choice_uninstall),GTK_OBJECT (window));
	gtk_widget_show (choice2);
	choice3 = gtk_radio_button_new_with_label( gtk_radio_button_group (GTK_RADIO_BUTTON (choice1)), "Update rules");
	gtk_signal_connect(GTK_OBJECT (choice3),"clicked",GTK_SIGNAL_FUNC(choice_update),GTK_OBJECT (window));
	gtk_widget_show (choice3);
	gtk_widget_set_sensitive(choice3,FALSE); //temporarily
	
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (choice1), TRUE);

	gtk_box_pack_start(GTK_BOX(vbox2),choice1,TRUE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox2),precompiled,TRUE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox2),choice2,TRUE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox2),choice3,TRUE,FALSE,0);

		
	gtk_container_set_border_width (GTK_CONTAINER (vbox2), 10);
	gtk_box_pack_start(GTK_BOX(vbox),vbox2,TRUE,FALSE,0);
	gtk_widget_show(vbox2);
	
	hbox=createButtonBox();

	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_widget_show (vbox);
	gtk_widget_show (hbox);
	gtk_widget_show (window);
	gtk_main ();

}
void show_uninstall_screen() {
	current_screen=UNINSTALL;
}
void show_update_screen() {
	current_screen=UPDATE;
}

int main( int argc,char *argv[] )
{
	gtk_init (&argc, &argv);
	current_screen=LICENSE;
	show_license_screen();	
	
	return 0;
}
