#!/bin/tcsh  -v
set tpath=/local

foreach td (  \
ucnet0000:/sec/dump/ucnet/0000_20_Jun_2000_aal5mux.trace  \
ucnet0100:/sec/dump/ucnet/0100_20_Jun_2000_aal5mux.trace  \
ucnet0200:/sec/dump/ucnet/0200_20_Jun_2000_aal5mux.trace  \
ucnet0300:/sec/dump/ucnet/0300_20_Jun_2000_aal5mux.trace  \
ucnet0400:/sec/dump/ucnet/0400_20_Jun_2000_aal5mux.trace  \
ucnet0500:/sec/dump/ucnet/0500_20_Jun_2000_aal5mux.trace  \
ucnet0600:/sec/dump/ucnet/0600_20_Jun_2000_aal5mux.trace  \
ucnet0700:/sec/dump/ucnet/0700_20_Jun_2000_aal5mux.trace  \
ucnet0800:/sec/dump/ucnet/0800_20_Jun_2000_aal5mux.trace  \
ucnet0900:/sec/dump/ucnet/0900_20_Jun_2000_aal5mux.trace  \
ucnet1000:/sec/dump/ucnet/1000_20_Jun_2000_aal5mux.trace  \
ucnet1100:/sec/dump/ucnet/1100_20_Jun_2000_aal5mux.trace  \
ucnet1200:/sec/dump/ucnet/1200_20_Jun_2000_aal5mux.trace  \
ucnet1300:/sec/dump/ucnet/1300_20_Jun_2000_aal5mux.trace\
ucnet1400:/sec/dump/ucnet/1400_20_Jun_2000_aal5mux.trace\
ucnet1500:/sec/dump/ucnet/1500_20_Jun_2000_aal5mux.trace\
ucnet1600:/sec/dump/ucnet/1600_20_Jun_2000_aal5mux.trace\
ucnet1700:/sec/dump/ucnet/1700_20_Jun_2000_aal5mux.trace\
ucnet1800:/sec/dump/ucnet/1800_20_Jun_2000_aal5mux.trace\
ucnet1900:/sec/dump/ucnet/1900_20_Jun_2000_aal5mux.trace\
ucnet2000:/sec/dump/ucnet/2000_20_Jun_2000_aal5mux.trace\
ucnet2100:/sec/dump/ucnet/2100_20_Jun_2000_aal5mux.trace\
ucnet2200:/sec/dump/ucnet/2200_20_Jun_2000_aal5mux.trace\
ucnet2300:/sec/dump/ucnet/2300_20_Jun_2000_aal5mux.trace\
        mra:/sec/dump/nlanr/nlanr.MRA.trace \
        aix:/sec/dump/nlanr/nlanr.AIX.trace \
        ind:/sec/dump/nlanr/nlanr.IND.trace \
        web:/sec/dump/webtrace \
        0dump2:/usr/traces/defcon_eth0.dump2 \
        0dump9:/usr/traces/defcon_eth0.dump9 \
        2dump2:/usr/traces/defcon_eth2.dump2 )
set suf=`echo $td | cut -d: -f1`
set trace=`echo $td | cut -d: -f2`
echo "TRACE: "$trace
set mquant=./mquant
time ./snort -N -A none -c ../etc/mwm.conf -r $trace >& mwm.instr.dat
time ./snort -N -A none -c ../etc/exb.conf -r $trace >& exb.instr.dat
cat mwm.instr.dat exb.instr.dat | grep pkt | ./mpaste > pst.dat
set exbt=`cat pst.dat|cut -d' ' -f6|awk -f ./awksum`
set mwmt=`cat pst.dat|cut -d' ' -f11|awk -f ./awksum`
set pt=`cat pst.dat|wc -l|sed s/\ //g`
cat pst.dat | cut -d' ' -f6,11 > scat.dat

cat pst.dat | cut -d' ' -f5 | sort -u | sort -n > nrulz.dat
echo "rules   %pkts     %cycles      med. cpp    avg. pkt"
echo "                 exb   mwm    exb   mwm   exb    mwm"
echo "===================================================="
foreach i ( `cat nrulz.dat ` )
cat pst.dat |awk '{if ($5=='$i') print $0;}' > pst-r-$i.dat
cat pst-r-$i.dat | cut -d' ' -f6,11 > scat-r-$i.dat
set ph=`cat scat-r-$i.dat|wc -l|sed s/\ //g`
set exba=`cat pst-r-$i.dat | cut -d' ' -f4| awk -f ./awkavg1`
set mwma=`cat pst-r-$i.dat | cut -d' ' -f9| awk -f ./awkavg1`
set exbc=`cat scat-r-$i.dat|cut -d' ' -f1|awk -f ./awksum`
set mwmc=`cat scat-r-$i.dat|cut -d' ' -f2|awk -f ./awksum`
set exbcc=`cat scat-r-$i.dat|cut -d' ' -f1|$mquant 0.5`
set mwmcc=`cat scat-r-$i.dat|cut -d' ' -f2|$mquant 0.5`
set exbr=`echo ""|awk '{ printf("%3.2f\n", (100*'$exbc'/'$exbt'))}'`
set mwmr=`echo ""|awk '{ printf("%3.2f\n", (100*'$mwmc'/'$mwmt'))}'`
set pr=`echo ${ph}00 / $pt | bc -l `
echo $i" "$pr" "$exbr" "$mwmr" "$exbcc" "$mwmcc $exba $mwma |awk '{printf("%3d     %5.2f   %3.2f  %3.2f  %5d %5d  %4d %6d\n", $1,$2,$3,$4,$5,$6,$7,$8);}'
end
echo ""
mkdir -p out-p4-$suf
mv -f {exb,mwm}.instr.dat nrulz.dat scat-r-*.dat pst-r-*.dat scat.dat pst.dat out-p4-$suf
end
